; 
; Env osztly
; 

.data
;	EnvRunProcs	dd offset ENV_ahdsr	;, offset ENV_adsr, offset ENV_adsr

	assume ecx:ptr ENV
.code
ENV_constructor		proc ; eax:dwCode
			;and	eax,0fh
			;push	dword ptr [EnvRunProcs+eax*4]
			push	offset ENV_ahdsr
			pop	[ecx].Run
			mov	eax,[ecx].out1
			mov	byte ptr [eax+3],0ffh
			mov	[ecx].bPhase,-1
			ret
ENV_constructor		endp

ENV_ahdsr	proc
; smp[0] = smp[frameSize];
; for (i=1; i<frameSize+1; i++)
; {
;	if (slopeUp)  { phase = 0; counter = attack*10*sampleRate; }
;	if (slopeDown) { phase = 4; counter = release*10*sampleRate; }
;	
;	switch (phase)
;	{
;		case 0: smp = pow(0.5,counter); break;
;		case 1: smp = 1.0;
;		case 2: smp = counter*(1.0-sustain)/decay/10/sampleRate+sustain; break;
;		case 3: smp = sustain; counter = 1.0; break;
;		case 4: smp = 1.0 - pow(0.5,counter); break;
;	}
;	if (counter-- < 0)
;	{
;		counter = in[phase]*10*sampleRate;
;		phase++;
;	}
; }
			push	ebp
			call MDL_prepareRun
			fld1
			mov	ebp,[ecx].out2
		@loop:
			call MDL_slope
			or	al,al
			mov	al,4
			jz @1
		@@:
			or	dl,dl
			jnz @2
				xor	al,al
		@1:
				mov	[ecx].bPhase,al
				mov	byte ptr [ecx+3].fCounter,80h
		@2:
			movzx	eax,[ecx].bPhase
			fld	[ecx].fCounter
			cmp	al,6
			jnc @N2
			fsub	[ecx].fDelta
			fst	real4 ptr [esp-4]
			test	byte ptr [esp-1],80h
			jns @H
			; fDelta = 1/in*sampleRate
				inc	al
				inc	[ecx].bPhase
;				cmp	al,6
;				jnc @N2
				fstp	st
				fld1
				fdiv	ssn_variables.fMixingFrequency
				mov	esi,[ecx+eax*4].in1
				fdiv	real4 ptr [esi+ebx*4]		; sampleRate*input
				fstp	dword ptr [ecx].fDelta
				fld1
		@H: ; 2
			cmp	al,6
			jnc @N2

			cmp	al,2
			jnz @S
				fld1
				jmp @next

		@S: ; 4
			mov	esi,[ecx].sustain
			fld	real4 ptr [esi+ebx*4]
			cmp	al,4
			jnz @A
				fld1
				fstp	st(2)
				jmp @next
		@A: ; 1
			fld	st(1)
			fmul	st,st
			dec	eax
			;cmp	al,1
			jnz @D
				fld1
				fsubrp	st(1),st
				fstp	st(1)
				jmp @next

		@D: ; 3
			cmp	al,3-1
			jnz @R
				fld1
				fsub	st,st(2)
				fmulp	st(1),st
				faddp	st(1),st
				jmp @next
		@R: ; 5
			fmulp	st(1),st
			jmp @next
		@N2:
			fldz
		@next:
			fst	real4 ptr [edi+ebx*4]
			fsub	st,st(2)
			fstp	real4 ptr [ebp+ebx*4]
			fstp	[ecx].fCounter
			cmp	ebx,FRAME_SIZE
			jc @loop
			fstp	st
			pop	ebp
			ret
ENV_ahdsr		endp

;ENV_hr			proc
;; smp[0] = smp[frameSize];
;; for (i=1; i<frameSize+1; i++)
;; {
;;	if ((rst[i-1] < 0) && (rst[i] >= 0)) counter = release*sampleRate/10.0;
;;	smp = pow(0.5,counter);
;;	counter += 10/release/sampleRate
;; }
;			call MDL_prepareRun
;		@loop:
;			call MDL_slopeUp
;			and	[ecx].fCounter,edx
;			mov	esi,[ecx].hrRelease
;		; xform release: delta = 10/(release*sampleRate)
;			fldc	10.0
;			fdiv	real4 ptr [esi+ebx*4]
;			fdiv	ssn_variables.fMixingFrequency
;			push	[ecx].fCounter
;			push	[ecx].fAlpha
;			call pow
;			fstp	real4 ptr [edi+ebx*4]
;			fadd	[ecx].fCounter
;			fstp	[ecx].fCounter
;			cmp	ebx,ssn_variables.dwFrameSize
;			jc @loop
;			ret
;ENV_hr			endp

	assume ecx:nothing