; 
; NET osztly
; 

.data
	include mdlClid.inc

	assume ecx:ptr NET

.code
NET_constructor		proc
			push	ecx
			invoke lpGlobalAlloc_,GPTR,2*0100h*4
			pop	ecx
			xor	edx,edx
			mov	[ecx+NET.lpModules],eax
			mov	[ecx+NET.dwModuleCount],edx
			add	eax,0100h*4
			mov	[ecx+NET.lpActiveModules],eax
			mov	[ecx+NET.dwActiveModuleCount],edx
;			mov	[ecx].Run,offset NET_run
			ret
NET_constructor		endp
NET_newModule		proc uses ebx esi edi ebp ; dwCode:eax
			mov	ebp,eax
			mov	ebx,[ecx+NET.dwModuleCount]		; modulok szma
			xor	eax,eax
			push	ecx
		ifndef MINIMALBUILD
			cmp	ebx,0100h
			jnc @end
		endif
			invoke lpGlobalAlloc_,GPTR,MDLSIZE
			mov	ecx,[esp]				; ecx: this
			shl	ebx,2
			mov	esi,eax
			add	ebx,[ecx+NET.lpModules]			; ebx: lpModules[dwModuleCount]
			mov	[esi+MDL.lpParent],ecx
			mov	edx,ebp
			mov	[ebx],eax
			inc	[ecx+NET.dwModuleCount]
			and	ebp,0ffh
			and	edx,0f0h				; classCode*16 -> mdlClasses[classCode]
			mov	eax,dword ptr [mdlClasses+edx+8]	; buildFromBinary metdus
			mov	[esi+MDL.BuildFromBinary],eax
			mov	eax,dword ptr [mdlClasses+edx]		; kimenetek szma
			lea	edi,dword ptr [mdlClasses+edx+4]	; konstruktor
			or	al,al
			jz @1
				push	eax
			ifdef MINIMALBUILD
				mov	ebx,FRAME_SIZE_IN_BYTES+4
			else
				mov	ebx,FRAME_SIZE_IN_BYTES
				add	ebx,4
			endif
				mul	ebx
				invoke lpGlobalAlloc_,GPTR,eax
		       		pop	ecx
		@@:		
				mov	[esi+ecx*4+MDL.out1-4],eax
				add	eax,ebx
				dec	ecx
				jnz @b
	@1:
	; bemenetek az res bufferra mutatnak
			xor	ecx,ecx
			mov	cl,7
			mov	eax,ssn_variables.lpBlankOutput
	@@:		
			mov	[esi+ecx*4+MDL.in1],eax
			dec	ecx
			jns @b
	; konstruktor
			mov	eax,ebp
			mov	ecx,esi
			mov	dword ptr [ecx+MDL.bType],eax
			call dword ptr [edi]
	@end:
			mov	eax,esi
			pop	ecx
			ret
NET_newModule		endp
NET_getModuleById	proc ; dwId:eax
			sub	al,1
			jnc @f
			mov	eax,ecx
			ret
		@@:
			mov	edx,eax
			xor	eax,eax
			cmp	edx,[ecx+NET.dwModuleCount]
			jnc @f
			shl	edx,2
			add	edx,[ecx+NET.lpModules]
			mov	eax,[edx]
		@@:
			ret
NET_getModuleById	endp
NET_getModuleByBuffer	proc uses ebx ecx esi ; lpBuffer:eax
			mov	esi,[ecx+NET.lpModules]
			mov	edx,[ecx+NET.dwModuleCount]
			xor	ecx,ecx
		@loop1:
			mov	cl,7
			mov	ebx,[esi+edx*4-4]
		@loop2:
			cmp	eax,[ebx+MDL.out1+ecx*4]
			jz @end
			dec	cl
			jns @loop2
			dec	edx
			jnz @loop1
			xor	ebx,ebx
		@end:
			mov	eax,ebx
			ret
NET_getModuleByBuffer	endp
NET_createModules	proc uses ebx esi ebp ; lpBinaryData:eax
			mov	esi,eax
			mov	ebp,eax
			add	esi,[eax]
			movzx	ebx,byte ptr [esi]
			inc	esi
		@loop:
			mov	eax,[esi]
			invoke NET_newModule
			cmp	byte ptr [esi],_net
			jnz @f
				inc	esi
				push	ecx
				movzx	edx,byte ptr [esi]		; net definci sorszma
				mov	ecx,eax
				mov	eax,[ebp+4+edx*4]		; binris definci offszetje
				add	eax,ebp
				invoke NET_createModules
				pop	ecx
		@@:
			inc	esi
			dec	ebx
			jnz @loop
			mov	[ecx].lpCustomData,esi			; a 2. szakaszra mutat
			ret
NET_createModules	endp
NET_ports		proc
			xor	ebx,ebx
		@@:
			movzx	eax,byte ptr [esi]
			inc	esi
			cmp	al,-1
			jz @f
			invoke NET_getModuleById
			movzx	edx,byte ptr [esi]
			mov	edx,[eax+edx*4+MDL.out1]
			inc	esi
			mov	[edi+ebx*4],edx
			inc	bl
			cmp	bl,8
			jc @b
		@@:
			mov	eax,esi
			ret
NET_ports		endp
NET_setupModules	proc uses edi
			mov	esi,[ecx].lpCustomData
		; modulok
			mov	eax,esi
			mov	ebx,[ecx].dwModuleCount
			mov	esi,[ecx].lpModules
			push	ecx
		@loop:
			mov	ecx,[esi]
			cmp	[ecx].bType,_net
			jnz @f
			; bemenetek, kimenetek
				push	ebx
				push	esi
				mov	esi,eax
				push	ecx
				lea	edi,[ecx].in1
				mov	ecx,[ecx+MDL.lpParent]
				invoke NET_ports
				pop	ecx
				lea	edi,[ecx].out1
				invoke NET_ports
				push	eax
				mov	eax,esi
				invoke NET_setupModules
				pop	eax
				pop	esi
				pop	ebx
				jmp @next
		@@:
			invoke [ecx+MDL.BuildFromBinary]
		@next:
			add	esi,4
			dec	ebx
			jnz @loop
			pop	ecx	
	
			ret
NET_setupModules	endp
NET_buildFromBinary	proc uses ebx esi edi ; lpBinaryData:eax
			invoke NET_createModules
			invoke NET_setupModules
			ret
NET_buildFromBinary	endp
NET_activeList@		proc ; lpMdl:eax
			test	[eax+MDL.bFlag],SSN_FLAG_VISITED
			jnz @end
		@@:
			push	ebx
			or	[eax+MDL.bFlag],SSN_FLAG_VISITED
			mov	ebx,eax
			xor	edx,edx
	@for1:
			mov	eax,[ebx+MDL.in1+edx*4]
			push	edx
			mov	ebp,eax
			cmp	eax,ssn_variables.lpBlankOutput
			jz @for1next
			mov	ecx,[ebx+MDL.lpParent]
		@1:
			mov	eax,ebp
			invoke NET_getModuleByBuffer
			or	eax,eax
			jnz @f
				mov	ecx,[ecx].lpParent
				jmp @1
		@@:
			mov	dl,[eax+MDL.bType]
			and	dl,0f0h
			cmp	dl,10h
			jz @for1next
			or	dl,dl
			jnz @f
				mov	ecx,eax
				jmp @1
		@@:
			invoke NET_activeList@
	@for1next:
			pop	edx
			inc	dl
			cmp	dl,8
			jc @for1
			mov	eax,[edi]
			mov	edx,[edi+4]
			mov	[eax+edx*4],ebx
			inc	dword ptr [edi+4]
			pop	ebx
	@end:
			ret
NET_activeList@		endp
NET_activeListClear	proc
			push	ebx
			mov	ebx,[ecx].lpModules
			mov	edx,[ecx].dwModuleCount
		@loop:
			mov	eax,[ebx+edx*4-4]
			cmp	[eax+MDL.bType],0
			jnz @f
				push	ecx
				push	edx
				mov	ecx,eax
				invoke NET_activeListClear
				pop	edx
				pop	ecx
		@@:
			and	[eax+MDL.bFlag],0ffh - SSN_FLAG_VISITED
			dec	edx
			jnz @loop
			pop	ebx
			ret
NET_activeListClear	endp
NET_activeList		proc uses ebx ecx edi ebp dwId:dword
			mov	eax,dwId
			invoke NET_getModuleById
			or	eax,eax
			jz @end
			push	eax
			invoke NET_activeListClear
			pop	eax
			lea	edi,[ecx].lpActiveModules
			invoke NET_activeList@
		@end:
			ret
NET_activeList		endp




;NET_getModuleByAddr	proc uses ebx esi ; dwAddr:eax
;			push	ebx
;			push	esi
;			xor	edx,edx
;			mov	esi,[ecx+NET.lpModules]
;		@loop:
;			mov	ebx,[esi+edx]
;			cmp	eax,ebx
;			jc @next
;			add	ebx,MDLSIZE
;			cmp	eax,ebx
;			jna @end
;		@next:
;			add	edx,4
;			cmp	edx,[ecx+NET.dwModuleCount]
;			jc @loop
;			xor	eax,eax
;			pop	esi
;			pop	ebx
;			ret
;		@end:
;			mov	eax,[esi+edx]
;			pop	esi
;			pop	ebx
;			ret
;NET_getModuleByAddr	endp
;NET_addOutput		proc ; eax:lpOutput, edx:outputId
;			push	eax
;			lea	eax,[ecx].out1
;			pop	dword ptr [eax+edx*4]
;			ret
;NET_addOutput		endp
;NET_addInput		proc ; eax:lpOutput, edx:outputId
;			push	eax
;			lea	eax,[ecx].out1
;			pop	dword ptr [eax+edx*4]
;			ret
;NET_addInput		endp
;NET_run			proc
;			ret
;NET_run			endp
	assume ecx:nothing