; 
; OP osztly
; 

.data
	Op1RunProcs	dd offset OP1_neg, offset OP1_not, offset OP1_div
			dd offset OP1_add2, offset OP1_mul2, offset OP1_div2
;			dd offset OP1_or2, offset OP1_and2
	assume ecx:ptr OP1

.code
OP1_constructor		proc ; eax:dwCode
			and	eax,0fh
			push	dword ptr [Op1RunProcs+eax*4]
			pop	[ecx].Run
			ret
OP1_constructor		endp
OP1_neg			proc uses ebp
			call MDL_prepareRun
			mov	esi,[ecx].in1
			mov	ebp,[ecx].out2
		@loop:
			inc	ebx
			mov	eax,[esi+ebx*4]
			mov	dl,[esi+ebx]
			xor	eax,80000000h
			neg	dl
			mov	[edi+ebx*4],eax
			mov	[ebp+ebx],dl
			cmp	ebx,FRAME_SIZE
			jc @loop
			ret
OP1_neg			endp
OP1_not			proc uses ebp
			call MDL_prepareRun
			mov	esi,[ecx].in1
			mov	ebp,[ecx].out2
		@loop:
			inc	ebx
			mov	dl,[esi+ebx]
			mov	eax,[esi+ebx*4]
			cmp	dl,0
			setg	[ebp+ebx]
			mov	edx,eax
			shl	edx,1
			sbb	edx,edx			; edx = (in < 0.0) ? -1 : 0
			and	eax,edx			; eax = (in < 0.0) ? 0 : eax
			mov	[edi+ebx*4],eax
			cmp	ebx,FRAME_SIZE
			jc @loop
			ret
OP1_not			endp
OP1_div			proc
			call MDL_prepareRun
			fld1
			mov	esi,[ecx].in1
		@loop:
			fld	st
			inc	ebx
			fdiv	real4 ptr [esi+ebx*4]
			fstp	real4 ptr [edi+ebx*4]
			cmp	ebx,FRAME_SIZE
			jc @loop
			fstp	st
			ret
OP1_div			endp
OP1_add2		proc uses ebp
			call MDL_prepareRun
			mov	esi,[ecx].in1
			mov	edx,[ecx].in2
			mov	ebp,[ecx].out2
		@loop:
			inc	ebx
			mov	al,[esi+ebx]
			fld	real4 ptr [esi+ebx*4]
			add	al,[edx+ebx]
			fadd	real4 ptr [edx+ebx*4]
			mov	[ebp+ebx],al
			fstp	real4 ptr [edi+ebx*4]
			cmp	ebx,FRAME_SIZE
			jc @loop
			ret
OP1_add2		endp
OP1_mul2		proc uses ebp
			call MDL_prepareRun
			mov	esi,[ecx].in1
			mov	edx,[ecx].in2
			mov	ebp,[ecx].out2
		@loop:
			inc	ebx
			mov	al,[esi+ebx]
			fld	real4 ptr [esi+ebx*4]
			mul	byte ptr [edx+ebx]
			fmul	real4 ptr [edx+ebx*4]
			mov	[ebp+ebx],al
			fstp	real4 ptr [edi+ebx*4]
			cmp	ebx,FRAME_SIZE
			jc @loop
			ret
OP1_mul2		endp
OP1_div2		proc
			call MDL_prepareRun
			mov	ebp,[ecx].out2
		@loop:
			mov	esi,[ecx].in1
			inc	ebx
;			xor	edx,edx
;			mov	al,[esi+ebx]
			fld	real4 ptr [esi+ebx*4]
			mov	esi,[ecx].in2
;			cmp	byte ptr [esi+ebx],0
;			jz @f
;				div	byte ptr [esi+ebx]
;		@@:
			fdiv	real4 ptr [esi+ebx*4]
;			mov	[ebp+ebx],al
			fstp	real4 ptr [edi+ebx*4]
			cmp	ebx,FRAME_SIZE
			jc @loop
			ret
OP1_div2		endp

;OP1_or2		proc
;			call MDL_prepareRun
;			mov	esi,[ecx].in1
;			mov	edx,[ecx].in2
;		@loop:
;			inc	ebx
;
;			cmp	ebx,ssn_variables.dwFrameSize
;			jc @loop
;			ret
;OP1_or2			endp
;
;OP1_and2		proc
;			call MDL_prepareRun
;			mov	esi,[ecx].in1
;			mov	edx,[ecx].in2
;		@loop:
;			inc	ebx
;
;			cmp	ebx,ssn_variables.dwFrameSize
;			jc @loop
;			ret
;OP1_and2		endp
	assume ecx:nothing
