; 
; SHP osztly
; 

.data
	SHPRunProcs		dd offset SHP_clp, offset SHP_delay, offset SHP_p2f, offset SHP_e2a, offset SHP_a2e

	dwMaxDelayInSamples	dd ?

	assume ecx:ptr SHP

.code
SHP_constructor		proc ; eax:dwCode
			push	eax
			and	eax,0fh
			push	dword ptr [SHPRunProcs+eax*4]
			pop	[ecx].Run
			pop	eax
			cmp	eax,_dly
			jnz @f
				imul	eax,ssn_variables.dwMixingFrequency,MAX_DELAY
				push	ecx
				mov	dwMaxDelayInSamples,eax
				shl	eax,2
				invoke lpGlobalAlloc_,GPTR,eax
				;push	eax
				;push	dword ptr GPTR
				;call lpGlobalAlloc_
				pop	ecx
				mov	[ecx].lpBuffer,eax
				mov	[ecx].dwPosition,0
		@@:
			ret
SHP_constructor		endp

SHP_clp			proc
			call MDL_prepareRun
			mov	esi,[ecx].in1
		@loop:
			inc	ebx
			mov	eax,[esi+ebx*4]
			mov	edx,[ecx].max
			cmp	eax,[edx+ebx*4]
			jle @f
				mov	eax,[edx+ebx*4]
				jmp @1
		@@:
			mov	edx,[ecx].min
			cmp	eax,[edx+ebx*4]
			jc @1
				mov	eax,[edx+ebx*4]
		@1:
			mov	[edi+ebx*4],eax
			
			cmp	ebx,FRAME_SIZE
			jc @loop
			ret
SHP_clp			endp

SHP_delay		proc
; d = delay;
; if (d < 0) d = 0;
; elseif (d > MAX_DELAY*1000) d = MAX_DELAY;
; d = d*sampleRate/1000+j;
; if (d > sampleRate*MAX_DELAY) d -= sampleRate*MAX_DELAY;
; buffer[d] = in1;
; out1[i] = buffer[j];
; if (j++ > bufferSize) j = 0;
			push	ebp
			call MDL_prepareRun
			mov	esi,[ecx].in1
			mov	ebp,[ecx].lpBuffer
		@loop:
			inc	ebx
			mov	edx,[ecx].delay
			mov	eax,[edx+ebx*4]
			test	eax,eax
			jns @f
				xor	eax,eax
		@@:
			push	ecx
			push	ebx
			mov	[esp-4],eax
			fld	real4 ptr ssn_variables.fMixingFrequency
			fmul	real4 ptr [esp-4]
			mov	ebx,1000
			fistp	dword ptr [esp-4]
			xor	edx,edx
			mov	eax,[esp-4]
			div	ebx
			mov	edx,[ecx].dwPosition
			cmp	eax,dwMaxDelayInSamples
			jc @f
				mov	eax,dwMaxDelayInSamples
				dec	eax
		@@:
			add	eax,edx
			cmp	eax,dwMaxDelayInSamples
			jc @f
				sub	eax,dwMaxDelayInSamples
		@@:
			inc	edx
			cmp	edx,dwMaxDelayInSamples
			jc @f
				xor	edx,edx
		@@:
			pop	ebx
			mov	[ecx].dwPosition,edx
			mov	ecx,[esi+ebx*4]
			mov	[ebp+eax*4],ecx
			mov	eax,[ebp+edx*4]
			mov	[edi+ebx*4],eax
			pop	ecx
			cmp	ebx,FRAME_SIZE
			jc @loop
			pop	ebp
			ret
SHP_delay		endp

SHP_p2f			proc
			push	ebp
			call MDL_prepareRun
			mov	ebp,ssn_variables.lpFreqTable
			mov	esi,[ecx].in1
		@loop:
			xor	eax,eax
			inc	ebx
			mov	al,[esi+ebx]
			cmp	al,132
			jc @f
				mov	al,132
		@@:
			mov	edx,[ebp+eax*4]
			mov	[edi+ebx*4],edx
			cmp	ebx,FRAME_SIZE
			jc @loop
			pop	ebp
			ret
SHP_p2f			endp

SHP_e2a			proc
			call MDL_prepareRun
			mov	ebp,ssn_variables.lpFreqTable
			mov	esi,[ecx].in1
		@loop:
			xor	eax,eax
			inc	ebx
			mov	al,[esi+ebx]
			fildc	eax
			fstp	real4 ptr [edi+ebx*4]
			cmp	ebx,FRAME_SIZE
			jc @loop
			ret
SHP_e2a			endp

SHP_a2e			proc
			call MDL_prepareRun
			mov	ebp,ssn_variables.lpFreqTable
			mov	esi,[ecx].in1
		@loop:
			inc	ebx
			fistp	dword ptr [esp-4]
			mov	al,[esp-4]
			mov	[edi+ebx],al
			cmp	ebx,FRAME_SIZE
			jc @loop
			ret	
SHP_a2e			endp
	assume ecx:nothing
