; 
; SSN_minimal - Nmeth Gbor 2009.05.20
; 

	.586
	.model flat, stdcall
	option casemap :none

;==============================
	include windows.inc
	include common.inc
	include ssn_m.inc

	method1 typedef proto :dword
	method2 typedef proto :dword,:dword

	extern lpGlobalAlloc_:ptr method2,lpGlobalFree_:ptr method1

.data
	ssn_variables		SSN_VARIABLES <>
	ssn_f12			real8 1.0594630943592952645618252949463

	include mdl.asm
	include net.asm
	include ctrl.asm
	include op1.asm
	include op2.asm
	include env.asm
	include osc.asm
	include flt.asm
	include seq.asm
	include shp.asm

.code
ssn_init	proc ; eax = dwMixFreq:dword, ecx = dwBufferSize:dword
		push	esi
		push	ebx
		mov	ebx,offset ssn_variables
		mov	[ebx+SSN_VARIABLES.dwFrameSize],ecx
		mov	[esp-4],eax
		fild	dword ptr [esp-4]
		mov	[ebx+SSN_VARIABLES.dwMixingFrequency],eax
		;fild	[ebx+SSN_VARIABLES.dwMixingFrequency]
		shl	ecx,2
		fstp	[ebx+SSN_VARIABLES.fMixingFrequency]
		mov	[ebx+SSN_VARIABLES.dwFrameSizeInBytes],ecx
		push	ecx
		add	ecx,12*12*4+4+sizeof NET
		invoke lpGlobalAlloc_,GPTR,ecx
		mov	esi,eax
		mov	[ebx+SSN_VARIABLES.lpFreqTable],eax
		add	eax,12*12*4
		mov	[ebx+SSN_VARIABLES.lpRootNet],eax
		add	eax,sizeof NET
		mov	[ebx+SSN_VARIABLES.lpBlankOutput],eax

		mov	ecx,12*12
		fld	real8 ptr ssn_f12
		fldc	27.5
	@@:
		fst	real4 ptr [esi]
		fmul	st,st(1)
		add	esi,4
		dec	ecx
		jnz @b
		fstp	st

		xor	edx,edx
		;add	eax,4
		pop	ecx
	@@:
		sub	ecx,4
		mov	[eax+ecx],edx
		jnc @b
		mov	ecx,[ebx+SSN_VARIABLES.lpRootNet]
		mov	eax,offset NET_buildFromBinary
		mov	[ecx+MDL.BuildFromBinary],eax
		invoke NET_constructor
		pop	ebx
		pop	esi
		ret
ssn_init	endp

ssn_setPatterns	proc ; eax = lpPatterns
; patternCount = (byte)*lpPatterns;
; p = lpPatterns;
; for (i=0;i<patternCount;i++)
; {
;	columnCount = ((byte)*p) & 7;	// as 5 bit
;	rowCount = ((byte)*p) >> 3	// fels 5 bit
;	
; }
		ret
ssn_setPatterns	endp

end