; szinti1
; 2 oscillator
; AEnv
; FEnv
; LP
; Mod: AM, FM, PM, CutM, FEnv
;
; A = AM * AEnv
; F = p2f(in1 + tune)
; C = Cut + CutM*22000 + FEnv


	sz1C1		equ 1
	sz1C2		equ sz1C1+1

	sz1A1		equ sz1C2+1
	sz1H1		equ sz1A1+1
	sz1D1		equ sz1H1+1
	sz1S1		equ sz1D1+1
	sz1R1		equ sz1S1+1
	sz1AEnv		equ sz1R1+1
	sz1AM		equ sz1AEnv+1 

	sz1A2		equ sz1AM+1
	sz1H2		equ sz1A2+1
	sz1D2		equ sz1H2+1
	sz1S2		equ sz1D2+1
	sz1R2		equ sz1S2+1
	sz1CEnv		equ sz1R2+1
	sz1CEnvM	equ sz1CEnv+1

	sz1Tune		equ sz1CEnvM+1
	sz1Detune	equ sz1Tune+1
	sz1Pitch	equ sz1Detune+1
	sz1FM20		equ sz1Pitch+1
	sz1FM1		equ sz1FM20+1
	sz1FM2		equ sz1FM1+1

	sz1Osc1		equ sz1FM2+1
	sz1Osc2		equ sz1Osc1+1

	sz1Ch1		equ sz1Osc2+1
	sz1Ch2		equ sz1Ch1+1
	sz1Amp1		equ sz1Ch2+1
	sz1Amp2		equ sz1Amp1+1
	sz1Mix		equ sz1Amp2+1

	sz1Cut		equ sz1Mix+1
	sz1Res		equ sz1Cut+1
	sz1CM		equ sz1Res+1
	sz1Flt1		equ sz1CM+1

	sz1Size equ sz1End - sz1Start
	sz1Out	equ sz1Flt1
	
	sz1Start	dd 4
			db sz1Flt1

			db _const, _const

			db _const, _const, _const, _const, _const, _ahdsr, _mul2
			db _const, _const, _const, _const, _const, _ahdsr, _mul4
			db _ctrl, _const, _add2, _p2f, _p2f, _add2

			db _saw
			db _saw

			db _const, _const
			db _mul2, _mul2
			db _add2

			db _const
			db _const
			db _add2
			db _flt2

			real4 1.0, 22000.0

			real4 0.5, 0.0, 0.2, 0.9, 0.2
			GATEBINDATA <0,00h>, <sz1A1,10h>, <sz1H1,20h>, <sz1D1,30h>, <sz1S1,40h>, <0,53h>
			db -1
			GATEBINDATA <0,02h>, <sz1AEnv,10h>	; sz1AM
			db -1
			real4 0.0, 0.0, 0.0, 1.0, 0.2
			GATEBINDATA <0,00h>, <sz1A2,10h>, <sz1H2,20h>, <sz1D2,30h>, <sz1S2,40h>, <0,53h>
			db -1
			GATEBINDATA <0,04h>, <sz1CEnv,10h>, <sz1C1,20h>, <sz1C2,30h>	; sz1CEnM
			db -1
			db 12
			real4 1.0
			GATEBINDATA <0,01h>, <sz1Tune,10h>
			db -1
			GATEBINDATA <sz1Pitch,01h>			; sz1FM20
			db -1
			GATEBINDATA <0,01h>				; sz1FM1
			db -1
			GATEBINDATA <sz1Detune,00h>, <sz1FM20,10h>	; sz1FM2
			db -1
			GATEBINDATA <0,00h>, <sz1FM1,10h>, <sz1AM,20h>	; sz1Osc1
			db -1
			GATEBINDATA <0,00h>, <sz1FM2,10h>, <sz1AM,20h>	; sz1Osc2
			db -1
			real4 0.4, 0.2
			GATEBINDATA <sz1Ch1,00h>, <sz1Osc1,10h>		; sz1Amp1
			db -1
			GATEBINDATA <sz1Ch2,00h>, <sz1Osc2,10h>		; sz1Amp2
			db -1
			GATEBINDATA <sz1Amp1,00h>, <sz1Amp2,10h>	; sz1Mix
			db -1
			real4 200.0, 0.5
			GATEBINDATA <sz1CEnvM,00h>, <sz1Cut,10h>
			db -1
			GATEBINDATA <sz1Mix,00h>, <sz1CM,10h>, <sz1Res,20h>
			db -1
	sz1End label byte